<?php
class Vlastnost extends Super{

  protected $id;
  protected $nazev;
  protected $titul;
  protected $jednotka;
  protected $stav = 1;  // default stav 

  protected $getter = array('id', 'nazev', 'titul', 'jednotka', 'stav');
  protected $setter = array( 'nazev', 'titul', 'jednotka', 'stav');
  public $validate = array(
  	'id'     => array('digits' => 'true'),
  	'nazev'  => array('required' => 'true', 'maxlength' => 35),
  	'titul'  => array('required' => 'true', 'maxlength' => 35),
    'jednotka' => array('maxlength' => 20),
    'stav'   => array('range' => '[0,1]' ) 
  );
  public $label = array(
  	'id'     => 'Id',
  	'nazev'  => 'Název',
  	'titul'  => 'Titulek',
    'jednotka' => 'Jednotka',
    'stav' 		 => 'Stav'
  );
  public $valAll = array(
  	'id'     => true,
  	'nazev'  => true,
  	'titul'  => true,
    'jednotka' => true,
    'stav' 		 => true
  );
	public $filtry = array(
      'ID' => array(
      	'type' => 'text',
				'key'	 => 'ID',
				'sql'	 => 'num',
    		'size' => 3
    	),
      'NAZEV' => array(
      	'type' => 'text',
    		'key'	 => 'NAZEV',
    		'sql'	 => 'text',
    		'size' => 12
    	),
      'TITUL' => array(
      	'type' => 'text',
    		'key'	 => 'TITUL',
    		'sql'	 => 'text',
    		'size' => 12
    	),
			'JEDNOTKA' => array(
      	'type' => 'text',
    		'key'	 => 'JEDNOTKA',
    		'sql'	 => 'text',
    		'size' => 8
    	),
      'S_NAZEV' => array(
      	'type' => 'stav',
    		'key'	 => 'STAV',
    		'sql'	 => 'num'
    	),
      'UPRAVIT' => array(
      	'type' => 'submit'
    	),
      'SMAZAT' => array(
      	'type' => 'all'
    	)
    );
  public $state_validate = array();

  function __construct() {
    /*
     * stavy:
     * 1 - aktivní
     * 2 - neaktivní
     */
    $this->state_validate[1] = $this->valAll;
    $this->state_validate[0] = $this->valAll;
    $this->table = 'VLASTNOST';

  }

  public function loadById($id, $hash = false, $postRestore = false) {
    $result = dibi::query('SELECT  E.*, S.NAZEV AS S_NAZEV, S.POPIS AS S_POPIS FROM ['.$this->table.'] AS E 
    	INNER JOIN STAV AS S ON S.STAV_ID = E.STAV AND ENTITA = %s
    	WHERE E.ID = %i;', $this->table, $id);

    if (count($result) == 0) {
      throw new Appliexception(1, 'Požadovaný záznam neexistuje', 'seznam', __METHOD__.' Neexistující záznam '.$id );
    }

    $row = $result->fetch()->getArrayCopy();
    $this->setFromRow($row);
    $this->my_stav = '<div title="'.$row['S_POPIS'].'" class="block_state"> '.$row['STAV'].' - '.$row['S_NAZEV'].'</div><br />';

    if ($hash) {
      $this->hash  = $this->getHash();
    } 

    $this->myStates();

    if ($postRestore) {
      $this->setFromPost();
    }
    return $this->toArray();
  }

  public function delete($id) {

  	dibi::query('DELETE FROM [VLASTNOST] WHERE ID = %i',$id);

  }
}
?>